Index: sandbox/workflow/branches/1015/setup/setup.inc.php
===================================================================
--- sandbox/workflow/branches/1015/setup/setup.inc.php	(revision 2042)
+++ sandbox/workflow/branches/1015/setup/setup.inc.php	(revision 3061)
@@ -16,6 +16,6 @@
 	$setup_info['workflow']['app_order']	= 10;
 	$setup_info['workflow']['enable']		= 1;
-	$setup_info['workflow']['author']		= 'Ported from tikiwiki, modified by regis_glc alpeb & mbartz<br>Customized to ExpressoLivre by viani, rodrigolira, mariceli, drovetto, carloseduardo, rufino, asaikawa, gbisotto, julianadelgado & rodsouza<br>See changeLog for full names.';
-	$setup_info['workflow']['note']			= 'Workflow engine';
+	$setup_info['workflow']['author']		= 'See changeLog for complete list of developers.';
+	$setup_info['workflow']['note']			= 'Workflow Engine';
 	$setup_info['workflow']['license']		= 'GPL';
 	$setup_info['workflow']['description']		= 'Workflow Management';
@@ -59,9 +59,9 @@
 	$setup_info['workflow']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('1.0.0','1.0.1','1.2', '2.0', '2.1')
+		'versions' => Array('1.0.0','1.0.1','1.2', '2.0', '2.1', '2.2')
 	);
 	$setup_info['workflow']['depends'][] = array(
 		'appname' => 'preferences',
-		'versions' => Array('1.0.0', '0.9.13.002', '2.0', '2.1')
+		'versions' => Array('1.0.0', '0.9.13.002', '2.0', '2.1', '2.2')
 	);
 ?>
Index: sandbox/workflow/branches/1015/setup/default_records.inc.php
===================================================================
--- sandbox/workflow/branches/1015/setup/default_records.inc.php	(revision 2042)
+++ sandbox/workflow/branches/1015/setup/default_records.inc.php	(revision 3061)
@@ -59,5 +59,5 @@
 $GLOBALS['phpgw']->ADOdb->query("INSERT INTO phpgw_config (config_app, config_name, config_value) VALUES(?, ?, ?)", array('workflow', 'log_type_file', 'True'));
 $GLOBALS['phpgw']->ADOdb->query("INSERT INTO phpgw_config (config_app, config_name, config_value) VALUES(?, ?, ?)", array('workflow', 'log_type_firebug', 'True'));
-$GLOBALS['phpgw']->ADOdb->query("INSERT INTO phpgw_config (config_app, config_name, config_value) VALUES(?, ?, ?)", array('workflow', 'log_level', '7'));
+$GLOBALS['phpgw']->ADOdb->query("INSERT INTO phpgw_config (config_app, config_name, config_value) VALUES(?, ?, ?)", array('workflow', 'log_level', '0'));
 
 /* connect to the new database */
Index: sandbox/workflow/branches/1015/setup/tables_current.inc.php
===================================================================
--- sandbox/workflow/branches/1015/setup/tables_current.inc.php	(revision 1229)
+++ sandbox/workflow/branches/1015/setup/tables_current.inc.php	(revision 3061)
@@ -190,9 +190,8 @@
 				'fd' => array(
 					'wf_parent_instance_id'	=> array('type' => 'int', 'precision' => '4', 'nullable' => False),
-					'wf_parent_activity_id'	=> array('type' => 'int', 'precision' => '4', 'nullable' => False),
 					'wf_child_instance_id' 	=> array('type' => 'int', 'precision' => '4', 'nullable' => False),
 					'wf_parent_lock' 		=> array('type' => 'int', 'precision' => '2', 'nullable' => True)
 				),
-				'pk' => array('wf_parent_instance_id', 'wf_parent_activity_id', 'wf_child_instance_id'),
+				'pk' => array('wf_parent_instance_id', 'wf_child_instance_id'),
 				'fk' => array(),
 				'ix' => array(),
Index: sandbox/workflow/branches/1015/setup/tables_update.inc.php
===================================================================
--- sandbox/workflow/branches/1015/setup/tables_update.inc.php	(revision 2042)
+++ sandbox/workflow/branches/1015/setup/tables_update.inc.php	(revision 3061)
@@ -1216,4 +1216,18 @@
 	{
 		#updating the current version
+		$GLOBALS['setup_info']['workflow']['currentver'] = '2.0.003';
+		return $GLOBALS['setup_info']['workflow']['currentver'];
+	}
+	$test[] = '2.0.003';
+	function workflow_upgrade2_0_003()
+	{
+		#updating the current version
+		$GLOBALS['setup_info']['workflow']['currentver'] = '2.0.004';
+		return $GLOBALS['setup_info']['workflow']['currentver'];
+	}
+	$test[] = '2.0.004';
+	function workflow_upgrade2_0_004()
+	{
+		#updating the current version
 		$GLOBALS['setup_info']['workflow']['currentver'] = '2.1.000';
 		return $GLOBALS['setup_info']['workflow']['currentver'];
@@ -1224,4 +1238,8 @@
 		if (!$GLOBALS['phpgw_setup']->oProc->m_bDeltaOnly)
 		{
+			/* updating log level */
+			$values = array('0', 'workflow', 'log_level');
+			$GLOBALS['phpgw']->ADOdb->query('UPDATE phpgw_config SET config_value=? WHERE config_app=? AND config_name=?', $values);
+
 			$workflowHostInfo = extractDatabaseParameters();
 
@@ -1260,4 +1278,13 @@
 			/* reconnect to the previous database */
 			$GLOBALS['phpgw']->ADOdb->connect($workflowHostInfo['host'], $workflowHostInfo['user'], $workflowHostInfo['password'], $workflowHostInfo['dbname']);
+
+			/* removing primary key of egw_wf_interinstance_relations */
+			$GLOBALS['phpgw']->ADOdb->query('ALTER TABLE egw_wf_interinstance_relations DROP CONSTRAINT egw_wf_interinstance_relations_pkey');
+
+			/* removing wf_parent_activity_id column from egw_wf_interinstance_relations table */
+			$GLOBALS['phpgw']->ADOdb->query('ALTER TABLE egw_wf_interinstance_relations DROP COLUMN wf_parent_activity_id');
+
+			/* adding primary key without the column removed */
+			$GLOBALS['phpgw']->ADOdb->query('ALTER TABLE egw_wf_interinstance_relations ADD CONSTRAINT egw_wf_interinstance_relations_pkey PRIMARY KEY (wf_parent_instance_id, wf_child_instance_id)');
 		}
 
Index: sandbox/workflow/branches/1015/lib/factory/WorkflowFactory.php
===================================================================
--- sandbox/workflow/branches/1015/lib/factory/WorkflowFactory.php	(revision 2588)
+++ sandbox/workflow/branches/1015/lib/factory/WorkflowFactory.php	(revision 3061)
@@ -63,4 +63,5 @@
 		$this->registerFileInfo('Thread', 'class.Thread.inc.php', 'inc');
 		$this->registerFileInfo('Paging', 'class.Paging.inc.php', 'inc');
+		$this->registerFileInfo('Logger', 'class.Logger.inc.php', 'inc');
 		$this->registerFileInfo('FsUtils', 'class.fsutils.inc.php', 'inc');
 		$this->registerFileInfo('UserPictureProvider', 'class.UserPictureProvider.inc.php', 'inc');
@@ -168,4 +169,15 @@
 
 
+		/**
+		 * TODO - This is another ATR - Alternative Technical Resource (common known
+		 * as workaround) to allow instantiation of "wf" classes. Although these classes
+		 * should have not been instanciated by the workflow module, some of them are
+		 * instantiated by run_activity during every execution. =(
+		 * In a new version of MVC these objects must be created by the Processes.
+		 */
+		$this->registerFileInfo('wf_natural', 'class.wf_natural.php', 'inc/local/classes');
+		$this->registerFileInfo('wf_db', 'class.wf_db.php', 'inc/local/classes');
+
+
 		/* ok. no more instances of this class.. */
 		self::$_instantiated = true;
Index: sandbox/workflow/branches/1015/inc/class.bo_utils.inc.php
===================================================================
--- sandbox/workflow/branches/1015/inc/class.bo_utils.inc.php	(revision 2372)
+++ sandbox/workflow/branches/1015/inc/class.bo_utils.inc.php	(revision 3061)
@@ -64,5 +64,5 @@
 	 */
 	function search_ldap_users_by_cn($params)
-	{
+	{ 
 		// parâmetro a ser procurado no ldap
 		$cn = trim(ereg_replace(' +', ' ', $params['cn']));
@@ -86,4 +86,6 @@
 			$ret_name = empty($params['name']) ? 'cn' : $params['name'];
 
+			$ret_complement = empty($params['complement']) ? '' : $params['complement'];
+
 			$ajaxConfig = &Factory::newInstance('ajax_config', 'contactcenter');
 			$config = $ajaxConfig->read_repository();
@@ -103,5 +105,9 @@
 
 				$filter     = '(&(uid=*)(phpgwAccountType=u)(!(phpgwAccountVisible=-1))(cn=*' . $cn . '*))';
-				$attrib_ret = array('cn', $ret_id, $ret_name);
+
+				if($ret_complement != '')
+					$attrib_ret = array('cn', $ret_id, $ret_name, $ret_complement);
+				else
+					$attrib_ret = array('cn', $ret_id, $ret_name);
 
 				$r = ldap_search($ds, $ldapconfig['basedn'], $filter, $attrib_ret, 0, 0, 5);
@@ -112,11 +118,30 @@
 					}
 					elseif(ldap_count_entries($ds, $r) < 200){
+
 						$result = ldap_get_entries($ds, $r);
-						foreach($result as $value){
-							$output['values'][] = array(
-								'id'   => $value[$ret_id],
-								'name' => trim(ucwords(strtolower($value[$ret_name][0]))));
+
+						foreach($result as $value){ 
+							if( ($value[$ret_name][0] != '') && ($value[$ret_complement][0] != '') ){
+									$complement = " >> " . $value[$ret_complement][0];
+									$output['values'][] = array(
+																 'id'   => $value[$ret_id],
+																 'name' => trim(ucwords(strtolower($value[$ret_name][0]))) . $complement
+															   ); 
+
+							}
+						elseif($value[$ret_name][0] != ''){
+								$output['values'][] = array(
+															 'id'   => $value[$ret_id],
+															 'name' => trim(ucwords(strtolower($value[$ret_name][0])))
+														   ); 
+							}
+						else{
+								$output['values'][] = array(
+															 'id'   => '',
+															 'name' => "-- Selecione uma Opção --"
+														   ); 
+							}
+
 						}
-
 
 						foreach ($output['values'] as $key => $value){
@@ -140,5 +165,5 @@
 		else{
 			$output['msg'] = 'Não digite caracteres especiais nem números. Apenas letras e espaços são permitidos.';
-		}
+		} 
 		return $output;
 	}
Index: sandbox/workflow/branches/1015/inc/class.run_activity.inc.php
===================================================================
--- sandbox/workflow/branches/1015/inc/class.run_activity.inc.php	(revision 2588)
+++ sandbox/workflow/branches/1015/inc/class.run_activity.inc.php	(revision 3061)
@@ -24,5 +24,5 @@
      */
 	class run_activity extends WorkflowUtils
-	{  	
+	{
 		/**
 		 * @var array  $public_functions func
@@ -50,5 +50,5 @@
 		 * @access public
 		 */
-		var $process;	
+		var $process;
 		/**
 		 * @var object $GUI  GUI engine object. Act carefully with it.
@@ -62,13 +62,13 @@
 		var $message = Array();
 		/**
-		 * @var object $categories categorie object for categories 
+		 * @var object $categories categorie object for categories
 		 * @access public
 		 */
 		var $categories;
 		/**
-		 * @var array $conf 
-		 * @access public
-		 */
-		var $conf = array();	
+		 * @var array $conf
+		 * @access public
+		 */
+		var $conf = array();
 		/**
 		 * @var $wf_template local activity template
@@ -76,10 +76,10 @@
 		 */
 		var $wf_template;
-		/** 
+		/**
 		 * @var object $instance
 		 * @access public
 		 */
 		var $instance;
-		/** 
+		/**
 		 * @var object $activity_type The type of activity
 		 * @access public
@@ -88,61 +88,61 @@
 		// then we retain all usefull vars as members, to make them avaible in user's source code
 		// theses are data which can be set before the user code and which are not likely to change because of the user code
-		/** 
-		 * @var int $process_id The process id 
+		/**
+		 * @var int $process_id The process id
 		 * @access public
 		 */
 		var $process_id;
-		/** 
-		 * @var int $activity_id The activity id 
+		/**
+		 * @var int $activity_id The activity id
 		 * @access public
 		 */
 		var $activity_id;
-		/** 
+		/**
 		 * @var int $process_name The process name
 		 * @access public
 		 */
 		var $process_name;
-		/** 
-		 * @var int $process_version The process_version 
+		/**
+		 * @var int $process_version The process_version
 		 * @access public
 		 */
 		var $process_version;
-		/** 
-		 * @var int $activity_name The process id 
+		/**
+		 * @var int $activity_name The process id
 		 * @access public
 		 */
 		var $activity_name;
-		/** 
-		 * @var int $user_name The user name 
+		/**
+		 * @var int $user_name The user name
 		 * @access public
 		 */
 		var $user_name;
-		/** 
-		 * @var int $view_activity activity id of the view activity avaible for this process 
+		/**
+		 * @var int $view_activity activity id of the view activity avaible for this process
 		 * @access public
 		 */
 		var $view_activity;
-		// theses 4 vars aren't avaible for the user code, they're set only after this user code was executed		
-		/** 
-		 * @var int $instance_id Instance id 
+		// theses 4 vars aren't avaible for the user code, they're set only after this user code was executed
+		/**
+		 * @var int $instance_id Instance id
 		 * @access public
 		 */
 		var $instance_id=0;
-		/** 
-		 * @var string $instance_name Instance name 
+		/**
+		 * @var string $instance_name Instance name
 		 * @access public
 		 */
 		var $instance_name='';
-		/** 
-		 * @var int $instance_owner Instance owner id 
+		/**
+		 * @var int $instance_owner Instance owner id
 		 * @access public
 		 */
 		var $instance_owner=0;
-		/** 
-		 * @var string $owner_name Owner name 
+		/**
+		 * @var string $owner_name Owner name
 		 * @access public
 		 */
 		var $owner_name='';
-		
+
 		/**
 		 * @var bool $print_mode print mode
@@ -155,11 +155,11 @@
 		 */
 		var $enable_print_mode = false;
-		
+
 		/**
 		 * @var array $act_role_names of roles associated with the activity, usefull for lists of users associated with theses roles
-		 * @access public	
+		 * @access public
 		 */
 		var $act_role_names= Array();
-		
+
 		/**
 		 * @var array $agents Array of ui_agent objects
@@ -172,20 +172,20 @@
 		 * @access public
 		 */
-		var $smarty;                
+		var $smarty;
 		/**
 		 * @var array $wf holds a global environment vector
 		 * @access public
 		 */
-		var $wf;                    
+		var $wf;
 		/**
 		 * @var $download_mode activates download mode
 		 * @access public
 		 */
-		var $download_mode;        
+		var $download_mode;
 		/**
 		 * @var string $_template_name holds the template's file name
 		 * @access public
 		 */
-		var $_template_name = null; 
+		var $_template_name = null;
 		/**
 		 * @var bool Indicates wether the current instance is a child instance or not
@@ -193,4 +193,5 @@
          */
 		var $isChildInstance = false;
+
 		/**
 		 * @var object Stores a 'workflow_smarty' object
@@ -200,7 +201,13 @@
 
 		/**
+		 * @var object Log Object
+         * @access private
+         */
+		private $logger = null;
+
+		/**
 		 * Constructor
-		 * 
-		 * @access public 
+		 *
+		 * @access public
 		 */
 		function run_activity()
@@ -218,4 +225,7 @@
 
 			$this->workflowSmarty 	= &Factory::getInstance('workflow_smarty', false);
+
+			// never configure a log of type "firebug" here. This will make goAjax stop running well =(
+			$this->logger 			= &Factory::getInstance('Logger', array('file'));
 
 			// TODO: open a new connection to the database under a different username to allow privilege handling on tables
@@ -236,4 +246,6 @@
 		function go($activity_id=0, $iid=0, $auto=0)
 		{
+			$totalTime = microtime(true);
+
 			$result=Array();
 
@@ -431,8 +443,8 @@
 
 			/* BEGIN WORKFLOW MVC SETTINGS */
-			$env = array( );                                           //create settings vector
+			$env = array();                                            //create settings vector
 			$env['view']          =& $smarty;                          //view layer instance
 			$env['template_file'] =& $_template_name;                  //template file to be shown
-			$env['dao']           =& wf_create_object('wf_db');        //data access object instance
+			$env['dao']			  =& Factory::newInstance('wf_db');    //data access object instance
 			$env['workflow']      =& $GLOBALS['workflow'];             //workflow environment information
 			$env['instance']      =& $instance;                        //process manager instance
@@ -441,5 +453,5 @@
 			$env['request']       =& $security->process($_REQUEST);    //sanitizes input data from client
 			$env['factory']       =& Factory::getInstance('ProcessWrapperFactory');  //instantiation controller class
-			$env['natural']		  =& wf_create_object('wf_natural');   //data access object instance for mainframe
+			$env['natural']		  =& Factory::newInstance('wf_natural');   //data access object instance for mainframe
 			/* END WORKFLOW MVC SETTINGS */
 
@@ -485,6 +497,10 @@
 
 			/* include the files */
+			$processTime = microtime(true);
+
 			foreach ($_engineFiles as $_engineFile)
 				require $_engineFile;
+
+			$processTime = (microtime(true) - $processTime);
 
 			unset($GLOBALS['workflow_env']);
@@ -528,6 +544,17 @@
 			}
 
+			$totalTime = (microtime(true) - $totalTime);
+
+			$logTime = sprintf("GO [pid=%s,iid=%s,uid=%s,aid=%s] [eng=%ss,proc=%ss]",
+								$this->process_id,
+								$this->instance_id,
+								$GLOBALS['user'],
+								$this->activity_id,
+								number_format(($totalTime - $processTime),3),
+								number_format($processTime,3) );
+
+			$this->logger->debug($logTime);
+
 			// TODO: process instance comments
-
 			$instructions = $this->runtime->handle_postUserCode(_DEBUG);
 			switch($instructions['action'])
@@ -593,4 +620,6 @@
 		function goAjax($activity_id=0, $iid=0, $auto=0)
 		{
+			$totalTime = microtime(true);
+
 			$result=Array();
 
@@ -702,6 +731,6 @@
 
 			/* BEGIN WORKFLOW MVC SETTINGS */
-			$env = array( );                                           //create settings vector
-			$env['dao']           =& wf_create_object('wf_db');        //data access object instance
+			$env = array();                                            //create settings vector
+			$env['dao']			  =& Factory::newInstance('wf_db');    //data access object instance
 			$env['workflow']      =& $GLOBALS['workflow'];             //workflow environment information
 			$env['instance']      =& $instance;                        //process manager instance
@@ -710,5 +739,5 @@
 			$env['request']       =& $security->process($_REQUEST); //sanitizes input data from client
 			$env['factory']       =& Factory::newInstance('ProcessWrapperFactory');  //instantiation controller class
-			$env['natural']		  =& wf_create_object('wf_natural');   //data access object instance for mainframe
+			$env['natural']		  =& Factory::newInstance('wf_natural');   //data access object instance for mainframe
 			/* END WORKFLOW MVC SETTINGS */
 
@@ -727,5 +756,5 @@
 			 * the messages for the process factory instead of Workflow
 			 * factory. Note that this is the same comment as the previous
-			 * function... boooring.. =}
+			 * function... boooring..
 			 */
 			Security::enable();
@@ -734,5 +763,9 @@
 			$nc = &Factory::newInstance('NanoController');
 			$nc->setClassPath(GALAXIA_PROCESSES . SEP . $this->process->getNormalizedName(). SEP . 'code');
+
+			$processTime = microtime(true);
 			$nc->iterateOverVirtualRequests();
+			$processTime = microtime(true) - $processTime;
+
 			$nc->outputResultData();
 			unset($GLOBALS['workflow_env']);
@@ -740,4 +773,16 @@
 			if (!is_null($iid))
 				$instance->instance->sync();
+
+			$totalTime = microtime(true) - $totalTime;
+
+			$logTime = sprintf("GOAJAX [pid=%s,iid=%s,uid=%s,aid=%s] [eng=%ss,proc=%ss]",
+								$this->process_id,
+								$this->instance_id,
+								$GLOBALS['user'],
+								$this->activity_id,
+								number_format(($totalTime - $processTime),3),
+								number_format($processTime,3) );
+
+			$this->logger->debug($logTime);
 		}
 
Index: sandbox/workflow/branches/1015/inc/local/functions/function.wf_create_object.php
===================================================================
--- sandbox/workflow/branches/1015/inc/local/functions/function.wf_create_object.php	(revision 795)
+++ sandbox/workflow/branches/1015/inc/local/functions/function.wf_create_object.php	(revision 3061)
@@ -5,5 +5,5 @@
  * @return mixed
  * @license http://www.gnu.org/copyleft/gpl.html GPL
- * @deprecated 1.4.00.000 - 08/03/2007
+ * @deprecated 2.2.00.000
  * @package Workflow 
  * @subpackage local 
@@ -12,4 +12,5 @@
 function wf_create_object($class_name)
 {
+	wf_warn_deprecated_method('Factory', 'getInstance');
 	$obj = null;
 	$file_name = PHPGW_SERVER_ROOT.SEP.'workflow'.SEP.'inc'.SEP.'local'.SEP.'classes'.SEP.'class.'.$class_name.'.php';
Index: sandbox/workflow/branches/1015/inc/local/classes/class.wf_instance.php
===================================================================
--- sandbox/workflow/branches/1015/inc/local/classes/class.wf_instance.php	(revision 2588)
+++ sandbox/workflow/branches/1015/inc/local/classes/class.wf_instance.php	(revision 3061)
@@ -250,29 +250,35 @@
 
 	/**
-	* Busca as instâncias filhas de uma instância
-	* Se os parâmetros não forem informados, retorna instâncias filhas das instância atual.
-	* @param int $instanceID O ID da instância pai (não obrigatório).
-	* @param int $activityID O ID da atividade corrente da instância pai
-	* @return array As instâncias filhas do par instância/atividade atual
-	* @access public
-	*/
-	public function getChildren($instanceID = null, $activityID = null)
+	* This method gets all children instances of the given instance.
+	* If there is no parameter, it gets the children instances of the current instance
+	* @param int $instanceID Dad instance's identification.
+	* @return array Array with the children instances, or false
+	* @access public
+	*/
+	public function getChildren($instanceID = null)
 	{
 		$output = array();
 		if (is_null($instanceID))
 			$instanceID = $GLOBALS['workflow']['wf_runtime']->instance_id;
-		if (is_null($activityID))
-			$activityID = $GLOBALS['workflow']['wf_runtime']->activity_id;
-
-		/* check instanceID */
-		if (!$this->checkInstanceAccess($instanceID, $activityID))
+
+		/* check instanceID */
+		if (!$this->checkInstanceAccess($instanceID))
 			return $output;
 
 		/* build the SQL query */
-		$query = 'SELECT i.wf_instance_id AS wf_instance_id, ia.wf_activity_id AS wf_activity_id, ia.wf_started AS wf_started, i.wf_name AS wf_name, i.wf_status AS wf_status, ia.wf_user AS wf_user, ir.wf_parent_lock AS wf_parent_lock ';
-		$query .= 'FROM egw_wf_interinstance_relations ir, egw_wf_instances i LEFT JOIN egw_wf_instance_activities ia ON (ia.wf_instance_id = i.wf_instance_id)';
-		$query .= 'WHERE (ir.wf_child_instance_id = i.wf_instance_id) AND (ir.wf_parent_instance_id = ?) AND (ir.wf_parent_activity_id = ?)';
-
-		$result = $this->db->query($query, array($instanceID, $activityID));
+		$query = 'SELECT i.wf_instance_id AS wf_instance_id, ' .
+				 '       ia.wf_activity_id AS wf_activity_id, ' .
+				 '       i.wf_started AS wf_started, ' .
+				 '       i.wf_name AS wf_name, ' .
+				 '       i.wf_status AS wf_status, ' .
+				 '       ia.wf_user AS wf_user, ' .
+				 '       ir.wf_parent_lock AS wf_parent_lock ' .
+				 ' FROM egw_wf_interinstance_relations ir, egw_wf_instances i ' .
+				 '  LEFT JOIN egw_wf_instance_activities ia ' .
+				 '  ON (ia.wf_instance_id = i.wf_instance_id) ' .
+				 ' WHERE ' .
+				 '  (ir.wf_child_instance_id = i.wf_instance_id) AND (ir.wf_parent_instance_id = ?) ';
+
+		$result = $this->db->query($query, array($instanceID));
 		$output = $result->GetArray(-1);
 
Index: sandbox/workflow/branches/1015/inc/local/classes/class.wf_engine.php
===================================================================
--- sandbox/workflow/branches/1015/inc/local/classes/class.wf_engine.php	(revision 2588)
+++ sandbox/workflow/branches/1015/inc/local/classes/class.wf_engine.php	(revision 3061)
@@ -86,8 +86,9 @@
 	* @return bool true caso a instância tenha sido continuada e false caso contrário.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function continueInstance($activityID, $instanceID)
 	{
+		wf_warn_deprecated_method('wf_instance', 'continueInstance');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->continueInstance($activityID, $instanceID);
@@ -99,8 +100,9 @@
 	* @return boolean true se foi possível abortar a instância e false caso contrário.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function abortInstance($instanceID)
 	{
+		wf_warn_deprecated_method('wf_instance', 'abort');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->abort($instanceID);
@@ -113,8 +115,9 @@
 	* @return boolean true se foi possível mudar o nome da instância e false caso contrário.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function setInstanceName($instanceID, $name)
 	{
+		wf_warn_deprecated_method('wf_instance', 'setName');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->setName($instanceID, $name);
@@ -127,8 +130,9 @@
 	* @return boolean true se foi possível mudar a prioridade da instância e false caso contrário.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function setInstancePriority($instanceID, $priority)
 	{
+		wf_warn_deprecated_method('wf_instance', 'setPriority');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->setPriority($instanceID, $priority);
@@ -141,8 +145,9 @@
 	* @return array As instâncias que satisfazem o critério de seleção.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function getIdleInstances($numberOfDays, $activities = null)
 	{
+		wf_warn_deprecated_method('wf_instance', 'getIdle');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getIdle($numberOfDays, $activities);
@@ -154,8 +159,9 @@
 	* @return array As instâncias que satisfazem o critério de seleção.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function getInstances($activities = null)
 	{
+		wf_warn_deprecated_method('wf_instance', 'getIdle');
 		return $this->getIdleInstances(0, $activities);
 	}
@@ -166,8 +172,9 @@
 	* @return array As instâncias que satisfazem o critério de seleção.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function getInstancesByName($name)
 	{
+		wf_warn_deprecated_method('wf_instance', 'getByName');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		$preOutput = $WFInstance->getByName($name);
@@ -187,10 +194,11 @@
 	* @return array As instâncias filhas do par instância/atividade atual
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function getChildInstances($instanceID = null, $activityID = null)
 	{
-		$WFInstance = &Factory::getInstance('wf_instance');
-		$preOutput = $WFInstance->getChildren($instanceID, $activityID);
+		wf_warn_deprecated_method('wf_instance', 'getChildren');
+		$WFInstance = &Factory::getInstance('wf_instance');
+		$preOutput = $WFInstance->getChildren($instanceID);
 		$output = array();
 		foreach ($preOutput as $childInstance)
@@ -206,8 +214,9 @@
 	* @return mixed Uma array contento as propriedades da instância (no formato "nome_da_propriedade" => "valor"). Ou false em caso de erro.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function getInstanceProperties($instanceID)
 	{
+		wf_warn_deprecated_method('wf_instance', 'getProperties');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getProperties($instanceID);
@@ -219,8 +228,9 @@
 	* @return array Propriedades da instância filha. Array no formato "nome_da_propriedade" => "valor".
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function getChildInstanceProperties($instanceID)
 	{
+		wf_warn_deprecated_method('wf_instance', 'getProperties');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getProperties($instanceID);
@@ -333,8 +343,9 @@
 	* @return array As instâncias que satisfazem o critério de seleção.
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function getUserInstances($users, $activities = null, $status = null)
 	{
+		wf_warn_deprecated_method('wf_instance', 'getByUser');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getByUser($users, $activities, $status);
@@ -346,8 +357,9 @@
 	* @return bool true caso a propriedade tenha sido alterada com sucesso
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function setInstanceProperty($instanceID, $nameProperty, $value)
 	{
+		wf_warn_deprecated_method('wf_instance', 'setProperty');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->setProperty($instanceID, $nameProperty, $value);
@@ -362,8 +374,9 @@
 	* @return bool true se o usuário tiver acesso à instância (levando em consideração $writeAccess) ou false caso contrário
 	* @access public
-	* @deprecated 1.7.00.000
+	* @deprecated 2.2.00.000
 	*/
 	function checkUserAccessToInstance($userID, $instanceID, $activityID, $writeAccess = true)
 	{
+		wf_warn_deprecated_method('wf_instance', 'checkUserAccess');
 		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->checkUserAccess($userID, $instanceID, $activityID, $writeAccess);
